package com.rv.im;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

import com.ruiwenliu.wrapper.base.BaseBean;
import com.ruiwenliu.wrapper.base.BaseStatusActivity;
import com.ruiwenliu.wrapper.weight.TitleView;
import com.rv.im.adapter.FriendSearchListAdapter;
import com.rv.im.bean.AddResultBean;
import com.rv.im.bean.FriendSearchBean;
import com.rv.im.db.service.FriendServiceImp;
import com.rv.im.db.table.ChatMessage;
import com.rv.im.presenter.AddFriendPresenter;
import com.rv.im.xmpp.listener.NewFriendListener;


/*******
 *
 * 添加好友功能
 *
 */
public class AddFriendActivity extends BaseStatusActivity<AddFriendPresenter> implements NewFriendListener {

    private EditText edtSearch;
    private Button btnSearch;

    private RecyclerView recyclerview;

    private FriendSearchListAdapter adapter;

    private String mKeyWord;

    private String userId;
    private String userName;

    private String addhaoyouid = null;

    @Override
    protected int setLayout() {
        return R.layout.activity_add_friend;
    }

    @Override
    protected void initView(Bundle savedInstanceState, TitleView titleView, Intent intent) {
        titleView.setTitle("添加好友");
        btnSearch = findViewById(R.id.btn_search);
        edtSearch = findViewById(R.id.edt_search);
        recyclerview = findViewById(R.id.recyclerview);
        recyclerview.setLayoutManager(new LinearLayoutManager(this, LinearLayout.VERTICAL, false));
        adapter = new FriendSearchListAdapter(null);
        adapter.setListener(new FriendSearchListAdapter.FriendItemClickListener() {
            @Override
            public void showDetail(FriendSearchBean.FriendSearItemBean item) {

            }

            @Override
            public void add(FriendSearchBean.FriendSearItemBean item) {
                userId = item.getUserId();
                userName = item.getNickname();
                int fromAddType;
                if (!TextUtils.isEmpty(userName) && userName.contains(mKeyWord)) {
                    fromAddType = 5;
                } else {
                    // 昵称不包含关键字的话就是通过手机号搜索出来的，
                    fromAddType = 4;
                }

                mPresenter.addFriend(userId, fromAddType);
            }
        });
        recyclerview.setAdapter(adapter);
        btnSearch.setOnClickListener(v -> {
            mKeyWord = edtSearch.getText().toString().trim();
            mPresenter.search(mKeyWord);
        });
    }

    private int isyanzheng = 0;// 该好友是否需要验证

    @Override
    public void onShowResult(int requestType, BaseBean result) {
        switch (requestType) {
            case 0:
                FriendSearchBean searchBean = (FriendSearchBean) result;
                if (searchBean != null && searchBean.resultCode == 1 && searchBean.getData() != null && searchBean.getData().size() > 0) {
                    adapter.setNewData(searchBean.getData());
                }
                break;
            case 1:
                AddResultBean addResultBean = (AddResultBean) result;

                if (addResultBean.resultCode == 1 && addResultBean.getData() != null) {
                    if (addResultBean.getData().getType() == 1 || addResultBean.getData().getType() == 3) {
                        isyanzheng = 0;// 需要验证
                        // 需要验证就发送打招呼的消息，
                        showToast("打招呼成功，静候回音");
                        mPresenter.doSayHello(null, userName, userId);
                    } else if (addResultBean.getData().getType() == 2 || addResultBean.getData().getType() == 4) {// 已经是好友了
                        isyanzheng = 1;// 不需要验证

                        // 在会员列表添加一条会员，里面内容为成功添加好友。
//                        NewFriendMessage message = NewFriendMessage.createWillSendMessage(
//                                coreManager.getSelf(), XmppMessage.TYPE_FRIEND, null, mUser);
//                        NewFriendDao.getInstance().createOrUpdateNewFriend(message);
//                        // 不需要验证的话直接加上，就发个xmpp消息，
//                        // 这里最终调用smack的方法发送xmpp消息，
//                        coreManager.sendNewFriendMessage(mUser.getUserId(), message);

                        // 数据库中添加好友
                        new FriendServiceImp(this).addMessage(mPresenter.buildAddFriendMessage(userId, userName, 2));

                        ChatMessage message = mPresenter.doSayAddFriend(userName, userId);
                        addhaoyouid = message != null ? message.getPackId() : "";
                        showToast("好友添加成功");

                    } else if (addResultBean.getData().getType() == 5) {
                        showToast(getString(R.string.add_attention_failed));
                    }
                }
                break;
        }
    }

    @Override
    public void onNewFriendSendStateChange(String toUserId, ChatMessage message, int messageState) {

    }

    @Override
    public boolean onNewFriend(ChatMessage message) {
        return false;
    }
}
